/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 108)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Window")
(use "DPath")
/******************************************************************************/
(instance public Intro3 of Rm
	(properties
		picture 104
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(67 139)
					loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
		(crownEgo:init()setCycle(StopWalk 6 7))
		(Mirror:init()setScript(mirrorEndScript))
		(Stand:init())
		(theHat:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (changeState newState)
		(var wWin, hWin, yStart, xStart, yFinish, xFinish, w, h, w2, h2, x, y)
		= state newState
		(switch(state)
			(case 0
				(= cycles 1)	
			)
			(case 1 
				SetCursor(997 FALSE)//(send gGame:setCursor(997 0))
				(crownEgo:view(6)loop(3)setCycle(Walk)
					setMotion(
						DPath 
						132 139 
						67 139 
						RoomScript
					)
				)
			)	
			(case 2 = cycles 22
				(crownEgo:hide())
				(send gGame:setSpeed(5))
				(changeHats:init()setCycle(End))
				Print(104 6 #dispose #width 234 #at (/ (- 320 234) 2) 143 #time 7)
			)
			(case 3 = cycles 20
				(theHat:cel(1))
			)
			(case 4
				(send gGame:setSpeed(8))
				(changeHats:hide())
				(send gEgo:show()loop(0)setCycle(Walk)setMotion(MoveTo 174 139 RoomScript))				
			)
			(case 5
				(send gEgo:setMotion(
						DPath 
						212 151 
						320 151
						RoomScript
					)
				)
			)						 
			(case 6
				 = cycles 2
				(send gEgo:hide())
			)
			(case 7
				ProgramControl()
				= gProgramControl FALSE
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			)
		)
	)
	
	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		(if (== (send pEvent:type) evKEYBOARD)
           	(if (== (send pEvent:message) KEY_ESCAPE)
				(if (not (TextWindow:dispose()))
           			(TextWindow:dispose())
					(send gRoom:newRoom(TITLESCREEN_SCRIPT))
				)(else
					(send gRoom:newRoom(TITLESCREEN_SCRIPT))
				 )
			)(else
				(if (== (send pEvent:message) KEY_RETURN)
					(if (not (TextWindow:dispose()))
           				(TextWindow:dispose())
						(send gRoom:newRoom(TITLESCREEN_SCRIPT))
					)(else
						(send gRoom:newRoom(TITLESCREEN_SCRIPT))
					 )
				)
			 )
		)		
		(if(== (send pEvent:type()) evMOUSEBUTTON)
			(if (not (TextWindow:dispose()))
           		(TextWindow:dispose())
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			)(else
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			 )
		)
		// handle Said's, etc...
	)

	
)

/******************************************************************************/
(instance mirrorEndScript of Script
    (properties)
    (method (changeState newState)
        = state newState
        (switch (state)
            (case 0 = cycles 8
                 (Mirror:setCycle(End))
            )(case 1
                 (Mirror:loop(0))
			 )
		)
	)
)

(instance crownEgo of Act
	(properties
		x 154
		y 103
		view 6
		loop 3
	)
)
(instance changeHats of Act
	(properties
		x 67
		y 139
		view 12
		loop 0
		cycleSpeed 1
	)
)
(instance Mirror of Prop
	(properties
		x 158
		y 46
		view 10
		loop 1
	)
)(instance theHat of Prop
	(properties
		x 52
		y 137
		z 24
		view 11
		loop 1
		cel 0
	)
)
(instance Stand of Prop
	(properties
		x 51
		y 137
		view 11
		loop 0
		cel 0
	)
)