/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 117)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Menubar")
(local
	text8
	text8shadow
)
/******************************************************************************/
(instance public SQDemo7 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn((send gEgo:x) (send gEgo:y))//150 130)
					loop (send gEgo:loop())//loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch (state)
			(case 0 (= cycles 1))
			(case 1 = cycles 50
				SetCursor(0 FALSE)
				= text8shadow Display(112 7
					dsCOORD 25 20
					dsCOLOUR clBLACK
					dsBACKGROUND clTRANSPARENT
					dsSAVEPIXELS
					dsWIDTH 270
					dsALIGN alCENTER
					dsFONT 3
					dsSAVEPIXELS
									 )
				= text8 Display(112 7
					dsCOORD 25 20
					dsCOLOUR clWHITE
					dsBACKGROUND clTRANSPARENT
					dsSAVEPIXELS
					dsWIDTH 270
					dsALIGN alCENTER
					dsFONT 2
					dsSAVEPIXELS
							   )
			)
			(case 2 = cycles 5
				= text8 Display("" dsRESTOREPIXELS text8)
				= text8shadow Display("" dsRESTOREPIXELS text8shadow)
			)
			(case 3
				EndCutscene()
				(send gGame:setSpeed(4))
				(send gRoom:newRoom(57))
			)
		)
	)
	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (== (send pEvent:type) evKEYBOARD)
           	(if (== (send pEvent:message) KEY_ESCAPE)
				EndCutscene()
				(send gGame:setSpeed(4))
				(send gRoom:newRoom(57))
			)
		)
	)
)
/******************************************************************************/