/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 14)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm014 of Rm
	(properties
		picture scriptNumber
		north 7
		east 0
		south 21
		west 13
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (if (>= (send gEgo:x) 150)
					(send gEgo:
               			posn(120 43)
               			loop(2)
					)
			   )(else
               		(send gEgo:
                   		posn((send gEgo:x) 43) //x is remembered
                   		loop(2)
               		)
				)
            )
            (case west
            	(if (< (send gEgo:y) 43)
            		(send gEgo:
            			posn(10 43)
            			loop(0)
					)
				)(else
					(send gEgo:
						posn(10 send gEgo:y)
						loop(0)
					)
				 )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(if (>= (send gEgo:y) 123 and <= (send gEgo:y) 152)
			(send gEgo:init()setCycle(StopWalk 3 3))
		)(else
			(send gEgo:init())
		 )
		(self:setRegions(701))
		(self:setLocales(702))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		
		(if (& (send gEgo:onControl()) ctlPURPLE)
			(send gRoom:newRoom(7))
		)
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('look>'))
			(if(Said('[/pond,water]'))
				Print(9 0)
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance ankleWater of Prop
    (properties
        x 0
        y 0
        view 2
        cel 0
	)
    (method (init)
        (super:init())
        (self:z(89))
        (self:setScript(anklewaterScript))
    )
)
 
(instance anklewaterScript of Script
    (properties)
    (method (doit)
        (ankleWater:
            posn((send gEgo:x) (- (send gEgo:y) -90))
            setPri(send gEgo:priority)
		)
        (super:doit())
	)
)