/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 54)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm054 of Rm
	(properties
		picture scriptNumber
		north 15
		east 0
		south 0
		west 53
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 10)  //x is remembered
                   loop(1)
               )
				(EgoSeahorse:init()setCycle(Fwd)setStep(5 5)setLoop(1))
				(MenuBar:hide()state(DISABLED))
				(SL:disable())
				(RoomScript:changeState(1))
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
                (EgoSeahorse:init()posn(10 98)setCycle(Fwd)setStep(5 5)setLoop(0))
				(RoomScript:changeState(4))
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
		
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 1
				(EgoSeahorse:setMotion(MoveTo 116 100 RoomScript))
			)
			(case 2
				(EgoSeahorse:setMotion(MoveTo 0 101 RoomScript))
			)
			(case 3
				(send gRoom:newRoom(53))
			)
			(case 4
				(EgoSeahorse:setMotion(MoveTo 116 100 RoomScript))
			)
			(case 5
				(EgoSeahorse:setMotion(MoveTo 200 60 RoomScript))
			)
			(case 6
				(send gRoom:newRoom(15))
			)
		)
	)
)
/******************************************************************************/
(instance EgoSeahorse of Act
	(properties
		x 200
		y 60
		view 14
		loop 1
	)
)