/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 56)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "DPath")
/******************************************************************************/
(instance public rm056 of Rm
	(properties
		picture scriptNumber
		north 0
		east 57
		south 0
		west 55
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		SetUpEgo()
		(switch(gPreviousRoomNumber)
            (case east
                (if(gCarpetFlying)
                	(send gEgo:init()hide())
                	(RoomScript:changeState(1))
				)(else
                	(send gEgo:
                		init()
                   		posn(310 send gEgo:y)  //y is remembered
                   		loop(1)
               		)
				 )
			)
            (case west
                (send gEgo:
                	init()
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
		)
		
		
		
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('ride>'))
			(if (Said('/carpet'))
				(self:setScript(CarpetScript))
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
			(case 1
				(EgoCarpet:
					init()
					setPri(send gEgo:priority())
					setStep(4 4)
					ignoreControl(ctlWHITE)
					setCycle(Fwd)
					setMotion(MoveTo 0 45 RoomScript)
				)
			)
			(case 2
				(send gRoom:newRoom(55))
			)
		)
	)
)
/******************************************************************************/
(instance EgoCarpet of Act
	(properties
		x 320
		y 45
		view 15
	)
)
(instance CarpetScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch(newState)
			(case 0
				ProgramControl()
				= gProgramControl TRUE
				= gCarpetFlying TRUE
				(send gEgo:hide())
				(EgoCarpet:
					setStep(4 4)
					setPri(send gEgo:priority())
					init()
					ignoreControl(ctlWHITE)
					posn((send gEgo:x) (send gEgo:y))
					loop(1)
					setCycle(Fwd)
					setMotion(DPath (- (send gEgo:x) 10) 45 0 45 CarpetScript)
				)
			)
			(case 1
				(send gRoom:newRoom(55))
			)
		)
	)
)