/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 59)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm059 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 60
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(if(== gDrawerOpen FALSE)
			(Drawer:init())
		)(else
			(Drawer:init()setCel(2))
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('open>'))
			(if(Said('/drawer'))
				(if(== gDrawerOpen FALSE)
					(if(send gEgo:inRect(54 114 96 150))						
						(if(not send gEgo:has(INV_CANDLE))
							(Drawer:setScript(drawerScript))
							(drawerScript:changeState(0))
						)(else
							(Drawer:setCycle(End))
							= gDrawerOpen TRUE
						 )
					)(else
						PrintNotCloseEnough()
				 	)
				)(else
					PrintItIs()
			 	)
			)
		)
		(if(Said('close>'))
			(if(Said('/drawer'))
				(if(== gDrawerOpen TRUE)				
					(if(send gEgo:inRect(54 114 96 150))
						(Drawer:setCycle(Beg))
						= gDrawerOpen FALSE
					)(else
						PrintNotCloseEnough()
				 	)
				)(else
					PrintItIs()
				 )
			)
		)
		(if(Said('get>'))
			(if(Said('/candle'))
				(if(not send gEgo:has(INV_CANDLE))
					(if(== gDrawerOpen TRUE)
						(if(send gEgo:inRect(54 114 96 150))
							PrintOK()
							(send gEgo:get(INV_CANDLE))
							(send gGame:changeScore(2))
						)(else
							PrintNotCloseEnough()
						 )
					)(else
						Print("You don't see a candle here")
					 )
				)(else
					PrintAlreadyTookIt()
				)
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Drawer of Prop
	(properties
		x 70
		y 128
		view 31
		cel 0
	)
)
(instance drawerScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch(state)
			(case 0
				ProgramControl()
				= gProgramControl TRUE
				= gDrawerOpen TRUE
				(Drawer:setCycle(End drawerScript))
			)
			(case 1 = cycles 3)				
			(case 2
				Print("There is a candle lying in the drawer of the old dresser.")
				PlayerControl()
				= gProgramControl FALSE
			)
		)
	)
)