/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 60)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm060 of Rm
	(properties
		picture scriptNumber
		north 59
		east 61
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('light/candle'))
			(if(send gEgo:has(INV_CANDLE))
				(if(== gLitCandle FALSE)				
					(if(send gEgo:inRect(69 66 978 74))
						Print("You light the candle.")
						= gLitCandle TRUE
						(send gGame:changeScore(1))
					)(else
						PrintNotCloseEnough()
			 		)
				)(else
					Print("You're candle is already lit.")
				 )
			)(else
				PrintDontHaveIt()
			 )
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
