/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 64)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm064 of Rm
	(properties
		picture scriptNumber
		north 63
		east 0
		south 0
		west 61
		horizon 72
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn(162 90) //x is remembered
                   loop(2)
               )
            )
            (case 94
                (send gEgo:
                   posn(253 124)  //y is remembered
                   loop(1)
               )
            )
            (case 65
                (send gEgo:
                   posn(253 124)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(40 124) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(if(not send gEgo:has(INV_HAM))
			(Ham:init()ignoreActors())
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if(== (send gEgo:onControl()) ctlNAVY)
			(if(== gLitCandle TRUE)
				(send gRoom:newRoom(65))
			)(else
				(send gRoom:newRoom(94))
			 )
		)
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('get>'))
			(if(Said('/meat'))
				(if(not send gEgo:has(INV_HAM))
					(if(< (send gEgo:distanceTo(Ham)) 20)
						PrintOK()
						(send gEgo:get(INV_HAM))
						(Ham:dispose())
						(send gGame:changeScore(2))
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					PrintAlreadyTookIt()
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Ham of Prop
	(properties		
		x 136
		y 137
		z 25
		view 19
	)
)