/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 75)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm075 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 80
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(self:setRegions(704))
		(if(not send gEgo:has(INV_NET))
			(aNet:
				init()
				ignoreActors()
			)
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('get>'))
			(if(Said('/net'))
				(if(send gEgo:has(INV_NET))
					PrintAlreadyTookIt()
				)(else
					(if(<= send gEgo:distanceTo(aNet) 20)
						Print("You reach down and retrieve the fishing net.")
						(send gEgo:get(INV_NET))
						(aNet:dispose())
						(send gGame:changeScore(1))
					)(else
						PrintNotCloseEnough()
					 )// end if close enough
				 )// end if has net
			)// end get net
		)// end get
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance aNet of Prop
	(properties
		x 114
		y 106
		view 36
	)	
)