/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 78)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm078 of Rm
	(properties
		picture scriptNumber
		north 0
		east 79
		south 83
		west 77
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(if(not (send gEgo:has(INV_AMULET)))
			(aAmulet:init()ignoreActors)
			Print("A glint of metal catches your eye. You look toward the direction of the glint and see an amulet lying on the ground.")
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('get>'))
			(if(Said('/amulet'))
				(if(not (send gEgo:has(INV_AMULET)))
					(if(<= (send gEgo:distanceTo(aAmulet)) 10)
						PrintOK()
						(send gEgo:get(INV_AMULET))
						(aAmulet:dispose())
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					PrintAlreadyTookIt()
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance aAmulet of Prop
	(properties
		x 40
		y 95
		view 67
	)
)