/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 94)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm094 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 64
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(43 60)
					loop(0)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(var dyingScript)
		(super:doit())		
		// code executed each game cycle
		(if((== (send gEgo:onControl()) ctlNAVY))
			(send gEgo:hide())
			ProgramControl()
			= gProgramControl TRUE
			= dyingScript ScriptID(DYING_SCRIPT)
			ShakeScreen(20 ssUPDOWN)
 			(send dyingScript:
    			caller(699)
    			register("It's dangerous to walk down a staircase in the dark!")
			)
  			(send gGame:setScript(dyingScript))
		)
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
