/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 105)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "DPath")
/******************************************************************************/
(instance public rm105 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case 55
				(send gEgo:
					posn(150 130)
					loop(1)
				)
				(RoomScript:changeState(3))
			)
			(default
				(send gEgo:
					posn(150 130)
					loop(1)
				)
				(RoomScript:changeState(1))
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
		(EgoCarpet:init()setStep(4 4))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 1
				(EgoCarpet:
					setStep(4 4)
					setCycle(Fwd)
					setMotion(
						DPath
						225 110
						320 95
						RoomScript
					)
				)
			)
			(case 2
				(send gRoom:newRoom(55))
			)
			(case 3
				(EgoCarpet:
					setStep(4 4)
					posn(320 95)
					loop(1)
					setCycle(Fwd)
					setMotion(
						DPath
						225 110
						20 190
						RoomScript
					)
				)
			)
			(case 4
				(send gRoom:newRoom(20))
			)
		)
	)
)
/******************************************************************************/
(instance EgoCarpet of Act
	(properties
		x 20
		y 190
		view 15
	)
)