/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 107)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Window")
/******************************************************************************/
(instance public rm107 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(send gGame:setSpeed(6))
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(150 130)
					loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
		(Face:init())
		(Mirror:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (changeState newState)
		(var wWin, hWin, yStart, xStart, yFinish, xFinish, w, h, w2, h2, x, y)
		= state newState
		(switch(state)
			(case 0 
				(= cycles 1)				
			)
			(case 1 = cycles 80
				(send gGame:setCursor(997 0))
				(TextWindow:
					setdim(235 42)
					hcenter(143)
					open()
					displaygui(104 4)
				)
			)
			(case 2 = cycles 5
				(TextWindow:dispose())
				(Face:setCycle(End))
			)
			(case 3 = cycles 70
				(TextWindow:
					setdim(235 42)
					hcenter(143)
					open()
					displaygui(104 5)
				)
			)
			(case 4 = cycles 8
				(Face:setCycle(Beg))
			)
			(case 5 = cycles 1
				(TextWindow:dispose())
				(send gRoom:newRoom(108))	
			)
		)
	)
	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		(if (== (send pEvent:type) evKEYBOARD)
           	(if (== (send pEvent:message) KEY_ESCAPE)
				(if (not (TextWindow:dispose()))
           			(TextWindow:dispose())
           			ProgramControl()
					= gProgramControl FALSE
					(send gRoom:newRoom(TITLESCREEN_SCRIPT))
				)(else
					ProgramControl()
					= gProgramControl FALSE
					(send gRoom:newRoom(TITLESCREEN_SCRIPT))
				 )
			)(else
				(if (== (send pEvent:message) KEY_RETURN)
					(if (not (TextWindow:dispose()))
           				(TextWindow:dispose())
           				ProgramControl()
						= gProgramControl FALSE
						(send gRoom:newRoom(TITLESCREEN_SCRIPT))
					)(else
						ProgramControl()
						= gProgramControl FALSE
						(send gRoom:newRoom(TITLESCREEN_SCRIPT))
					 )
				)
			 )
		)		
		(if(== (send pEvent:type()) evMOUSEBUTTON)
			(if (not (TextWindow:dispose()))
           		(TextWindow:dispose())
           		ProgramControl()
				= gProgramControl FALSE
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			)(else
				ProgramControl()
				= gProgramControl FALSE
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			 )
		)
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Face of Prop
	(properties
		x 93
		y 48
		view 902
	)
)
(instance Mirror of Prop
	(properties
		x 236
		y 90
		view 903
		loop 1
	)
)