/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 112)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(local
	text1
	text1shadow
	text2
	text2shadow
)
/******************************************************************************/
(instance public rm112 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn((send gEgo:x) (send gEgo:y))//150 130)
					loop (send gEgo:loop())//loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
		(send gGame:setCursor(0 0))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch (state)
			(case 0
				(= cycles 1)
			)
			(case 1 = cycles 40
				(send gGame:setCursor(0 0))
				= text1shadow Display(112 0
					dsCOORD 25 163
					dsCOLOUR clBLACK
					dsBACKGROUND clTRANSPARENT
					dsSAVEPIXELS
					dsWIDTH 270
					dsALIGN alCENTER
					dsFONT 3
					dsSAVEPIXELS
									 )
				= text1 Display(112 0
					dsCOORD 25 163
					dsCOLOUR clFUCHSIA
					dsBACKGROUND clTRANSPARENT
					dsSAVEPIXELS
					dsWIDTH 270
					dsALIGN alCENTER
					dsFONT 2
					dsSAVEPIXELS
							   )
			)
			(case 2 = cycles 5
				= text1 Display("" dsRESTOREPIXELS text1)
				= text1shadow Display("" dsRESTOREPIXELS text1shadow)
			)
			(case 3 = cycles 60
				= text2shadow Display(112 1
					dsCOORD 25 153
					dsCOLOUR clBLACK
					dsBACKGROUND clTRANSPARENT
					dsSAVEPIXELS
					dsWIDTH 270
					dsALIGN alCENTER
					dsFONT 3
					dsSAVEPIXELS
									 )
				= text2 Display(112 1
					dsCOORD 25 153
					dsCOLOUR clFUCHSIA
					dsBACKGROUND clTRANSPARENT
					dsSAVEPIXELS
					dsWIDTH 270
					dsALIGN alCENTER
					dsFONT 2
					dsSAVEPIXELS
							   )
			)
			(case 4 = cycles 5
				= text2 Display("" dsRESTOREPIXELS text2)
				= text2shadow Display("" dsRESTOREPIXELS text2shadow)
			)
			(case 5 = cycles 1
				(send gRoom:newRoom(113))
			)
		)
	)
	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (== (send pEvent:type) evKEYBOARD)
           	(if (== (send pEvent:message) KEY_ESCAPE)
           		ProgramControl()
				= gProgramControl FALSE
				(send gRoom:newRoom(1))
			)(else
				(if (== (send pEvent:message) KEY_RETURN)
					ProgramControl()
					= gProgramControl FALSE
					(send gRoom:newRoom(1))
				)
			 )
		)					
		(if(== (send pEvent:type()) evMOUSEBUTTON)
			ProgramControl()
			= gProgramControl FALSE
			(send gRoom:newRoom(1))
		)
	)
)
/******************************************************************************/