/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 116)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(local
	text6
	text6shadow
	text7
	text7shadow
)
/******************************************************************************/
(instance public rm116 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn((send gEgo:x) (send gEgo:y))//150 130)
					loop (send gEgo:loop())//loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
		(send gGame:setCursor(0 0))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch (state)
			(case 0 (= cycles 1))
			(case 1 = cycles 40
				(send gGame:setCursor(0 0))
				= text6shadow Display(112 5
					dsCOORD 25 5
					dsCOLOUR clBLACK
					dsBACKGROUND clTRANSPARENT
					dsSAVEPIXELS
					dsWIDTH 270
					dsALIGN alCENTER
					dsFONT 3
					dsSAVEPIXELS
									 )
				= text6 Display(112 5
					dsCOORD 25 5
					dsCOLOUR clRED
					dsBACKGROUND clTRANSPARENT
					dsSAVEPIXELS
					dsWIDTH 270
					dsALIGN alCENTER
					dsFONT 2
					dsSAVEPIXELS
							   )
			)
			(case 2 = cycles 5
				= text6 Display("" dsRESTOREPIXELS text6)
				= text6shadow Display("" dsRESTOREPIXELS text6shadow)
			)
			(case 3 = cycles 50
				= text7shadow Display(112 6
					dsCOORD 25 5
					dsCOLOUR clBLACK
					dsBACKGROUND clTRANSPARENT
					dsSAVEPIXELS
					dsWIDTH 270
					dsALIGN alCENTER
					dsFONT 3
					dsSAVEPIXELS
									 )
				= text7 Display(112 6
					dsCOORD 25 5
					dsCOLOUR clRED
					dsBACKGROUND clTRANSPARENT
					dsSAVEPIXELS
					dsWIDTH 270
					dsALIGN alCENTER
					dsFONT 2
					dsSAVEPIXELS
							   )
			)
			(case 4 = cycles 5
				= text7 Display("" dsRESTOREPIXELS text7)
				= text7shadow Display("" dsRESTOREPIXELS text7shadow)
			)
			(case 5
				(send gRoom:newRoom(117))
			)
		)
	)
	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (== (send pEvent:type) evKEYBOARD)
           	(if (== (send pEvent:message) KEY_ESCAPE)
           		ProgramControl()
				= gProgramControl FALSE
				(send gRoom:newRoom(1))
			)(else
				(if (== (send pEvent:message) KEY_RETURN)
					ProgramControl()
					= gProgramControl FALSE
					(send gRoom:newRoom(1))
				)
			 )
		)					
		(if(== (send pEvent:type()) evMOUSEBUTTON)
			ProgramControl()
			= gProgramControl FALSE
			(send gRoom:newRoom(1))
		)
	)
)
/******************************************************************************/
