/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 120)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm120 of Rm
	(properties
		picture 50
		north 138
		east 121
		south 123
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 75) //x is remembered
                   loop(2)
               )
            )
            (case east
               (send gEgo:
                   posn(310 (send gEgo:y))  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 (send gEgo:y)) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
			(default
				(send gEgo:
					posn(150 130)
					loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()setCycle(StopSwim gEgoSwimming gEgoSwimming))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		(if (& (send gEgo:onControl()) ctlPURPLE)
			(send gRoom:newRoom(138))
		)
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(var dyingScript)
		(= state newState)
		(switch (newState)
			(case 0 = seconds 7
				
			)
			(case 1 = seconds 14
				Print("Your arms are getting very tired.")
			)
			(case 2
				Print("The strain on your muscles is too much. You can no longer swim.")
				= dyingScript ScriptID(DYING_SCRIPT)
 				(send dyingScript:
    				caller(699)
    				register("Next time don't spend that much time out in the vast ocean.")
  					)
  				(send gGame:setScript(dyingScript))
			)			
		)
	)
)
/******************************************************************************/
