/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script INTROCREDITS_SCRIPT)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public IntroCredits of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(send gGame:setSpeed(2))
		ProgramControl()
		= gProgramControl TRUE
		(self:setScript(RoomScript))
		
		SetUpEgo()
		(send gEgo:init()hide())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (== (send pEvent:type) evKEYBOARD)
           	(if (== (send pEvent:message) KEY_RETURN)
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0 = cycles 2
			)
			(case 1 = cycles 40
				(ExecProd:init()setMotion(MoveTo 160 50)setStep(1 1))
			)
			(case 2 = cycles 130
				(bBlume:init()setMotion(MoveTo 160 50)setStep(1 1))
			)
			(case 3 = cycles 10
				(ExecProd:dispose())
			)
			(case 4 = cycles 1
				(bBlume:posn(160 190))
			)
			(case 5 = cycles 40
				(GameDes:init()setMotion(MoveTo 160 50)setStep(1 1))
			)
			(case 6 = cycles 130
				(bBlume:setMotion(MoveTo 160 50))
			)
			(case 7 = cycles 10
				(GameDes:dispose())
			)
			(case 8 = cycles 1
				(bBlume:posn(160 190))
			)
			(case 9 = cycles 40
				(Prod:init()setMotion(MoveTo 160 50)setStep(1 1))
			)
			(case 10 = cycles 130
				(bBlume:setMotion(MoveTo 160 50))
			)
			(case 11 = cycles 10
				(Prod:dispose())
			)
			(case 12 = cycles 1
				(bBlume:posn(160 190))
			)
			(case 13 = cycles 40
				(ArtDes:init()setMotion(MoveTo 160 50)setStep(1 1))
			)
			(case 14 = cycles 130
				(bBlume:setMotion(MoveTo 160 50))
			)
			(case 15 = cycles 10
				(ArtDes:dispose())
			)
			(case 16 = cycles 1
				(bBlume:posn(160 190))
			)
			(case 17 = cycles 40
				(LeadProg:init()setMotion(MoveTo 160 50)setStep(1 1))
			)
			(case 18 = cycles 130
				(bBlume:setMotion(MoveTo 160 50))
			)
			(case 19 = cycles 10
				(LeadProg:dispose())
			)
			(case 20 = cycles 1
				(bBlume:posn(160 190))
			)
			(case 21 = cycles 40
				(Comp:init()setMotion(MoveTo 160 50)setStep(1 1))
			)
			(case 22 = cycles 130
				(bBlume:setMotion(MoveTo 160 50))
			)
			(case 23 = cycles 10
				(Comp:dispose())
			)
			(case 24 = cycles 10
				(bBlume:dispose())
			)
			(case 25
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			)
/*			(case  = cycles 40
				Display("Credit sequence\n"+
					"from intro."
					dsCOORD 1 52
					dsALIGN alCENTER
					dsWIDTH 320
					dsFONT 1
					dsCOLOUR clWHITE
					dsBACKGROUND clTRANSPARENT
					)
			)*/
		)
	)
)
/******************************************************************************/
(instance ExecProd of Act
	(properties
		x 160
		y 190
		view 951
	)
)
(instance GameDes of Act
	(properties
		x 160
		y 190
		view 952
	)
)
(instance Prod of Act
	(properties
		x 160
		y 190
		view 953
	)
)
(instance ArtDes of Act
	(properties
		x 160
		y 190
		view 954
	)
)
(instance LeadProg of Act
	(properties
		x 160
		y 190
		view 955
	)
)
(instance Comp of Act
	(properties
		x 160
		y 190
		view 956
	)
)
(instance bBlume of Act
	(properties
		x 160
		y 190
		view 963
	)
)