/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 111)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Menubar")
/******************************************************************************/
(instance public SQDemo1 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(send gGame:setSpeed(6))
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn((send gEgo:x) (send gEgo:y))//150 130)
					loop (send gEgo:loop())//loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
		StartCutscene()
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch (state)
			(case 0 
				(= cycles 1)
			)
			(case 1
				= cycles 40
				SetCursor(0 FALSE)
			)
			(case 2 = cycles 70
				Display("The Sarien Encounter"
					dsALIGN alCENTER
					dsFONT 9
					dsCOORD 1 156
					dsWIDTH 320
					dsCOLOUR clMAROON
					dsBACKGROUND clTRANSPARENT
					   )
			)
			(case 3
				(send gRoom:newRoom(112))
			)
		)
	)
		
	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (== (send pEvent:type) evKEYBOARD)
           	(if (== (send pEvent:message) KEY_ESC)
				EndCutscene()
				(send gGame:setSpeed(4))
				(send gRoom:newRoom(57))
			)
		)
	)
)
/******************************************************************************/