/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script INTROCREDITS_SCRIPT)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public TitleCredits of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		ProgramControl()
		= gProgramControl TRUE
		(self:setScript(RoomScript))
		(send gGame:setSpeed(2))
		
		SetUpEgo()
		(send gEgo:init()hide())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		(if (== (send pEvent:type) evKEYBOARD)
			(if (== (send pEvent:message) KEY_RETURN)
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				(= cycles 2)
			)
			(case 1 = cycles 40
				(Cred:init()setMotion(MoveTo 160 50)setStep(3 1))
			)
			(case 2 = cycles 130
				(Name:init()setMotion(MoveTo 160 50)setStep(3 1))
			)
			(case 3 = cycles 10
				(Cred:hide()posn(160 190))
			)
			(case 4 = cycles 1
				(Name:posn(160 190))
			)
			(case 5 = cycles 40
				(Cred:view(952)show()setMotion(MoveTo 160 50))
			)
			(case 6 = cycles 130
				(Name:setMotion(MoveTo 160 50))
			)
			(case 7 = cycles 10
				(Cred:hide()posn(160 190))
			)
			(case 8 = cycles 1
				(Name:posn(160 190))
			)
			(case 9 = cycles 40
				(Cred:view(953)show()setMotion(MoveTo 160 50))
			)
			(case 10 = cycles 130
				(Name:setMotion(MoveTo 160 50))
			)
			(case 11 = cycles 10
				(Cred:hide()posn(160 190))
			)
			(case 12 = cycles 1
				(Name:posn(160 190))
			)
			(case 13 = cycles 40
				(Cred:view(954)show()setMotion(MoveTo 160 50))
			)
			(case 14 = cycles 130
				(Name:setMotion(MoveTo 160 50))
			)
			(case 15 = cycles 10
				(Cred:hide()posn(160 190))
			)
			(case 16 = cycles 1
				(Name:posn(160 190))
			)
			(case 17 = cycles 40
				(Cred:view(955)show()setMotion(MoveTo 160 50))
			)
			(case 18 = cycles 130
				(Name:setMotion(MoveTo 160 50))
			)
			(case 19 = cycles 10
				(Cred:hide()posn(160 190))
			)
			(case 20 = cycles 1
				(Name:posn(160 190))
			)
			(case 21 = cycles 40
				(Cred:view(956)show()setMotion(MoveTo 160 50))
			)
			(case 22 = cycles 130
				(Name:setMotion(MoveTo 160 50))
			)
			(case 23 = cycles 10
				(Cred:dispose())
			)
			(case 24 = cycles 10
				(Name:dispose())
			)
			(case 25
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			)
		)
	)
)
/******************************************************************************/
(instance Cred of Act
	(properties
		x 160
		y 190
		view 951
	)
)
(instance Name of Act
	(properties
		x 160
		y 190
		view 963
	)
)