/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 4)
/******************************************************************************/
(use "controls")
(use "cycle")
(use "door")
(use "feature")
(use "game")
(use "inv")
(use "main")
(use "obj")
/******************************************************************************/
(instance public rm004 of Rm
	(properties
		picture scriptNumber
		north 46
		east 5
		south 11
		west 3
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))

  (switch(gPreviousRoomNumber)
            (case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
               (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
            (default
				(send gEgo:
					posn(10 130)
					loop(0)
				)
			)
		)

		SetUpEgo()
		(send gEgo:init())
		(self:setLocales(702))
		//LITTLE RED RIDING HOOD GOES HERE
	)
)
/******************************************************************************/
(instance RoomScript of Script
    (properties)
    (method (handleEvent pEvent)
        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
     /*   (if(Said('look / '))
            Print("")
        )*/
        (if(Said('look>'))
        	(if(Said('fence'))
            Print(4 0)
        	)
		)
        (if(Said('*/fence'))
            Print(2 1)
        )
    )
)
/******************************************************************************/
