/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 6)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm006 of Rm
	(properties
		picture scriptNumber
		north 48
		east 7
		south 13
		west 5
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
				(send gEgo:
	               	posn(283 75) //x is remembered
					loop(2)
				)
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (if(< (send gEgo:y()) 92)
                	(send gEgo:
                		posn(246 send gEgo:y)
                		loop(0)
					)
				)(else
                	(send gEgo:
                    	posn(10 send gEgo:y) //y is remembered
                    	loop(0)
                	)
				 )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
			)
            (case 71
            	(send gEgo:
                   posn(157 127)
                   loop(2)
				)
			)
            
		)
		
		SetUpEgo()
		(send gEgo:init())
		(self:setLocales(702))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if(== (send gEgo:onControl()) ctlPURPLE)
			(send gRoom:newRoom(48))	
		)
		(if(== (send gEgo:onControl()) ctlGREEN)
			(send gRoom:newRoom(71))	
		)
		(if(== (send gEgo:onControl()) ctlBLUE)
			(send gRoom:newRoom(5))	
		)
		
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('look>'))
			(if(Said('/window'))
				Print(5 2)
			)
			(if(Said('/door'))
				Print(6 0)
			)
			(if(Said('[/(around,building)]'))
				Print(5 0)
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
