/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 8)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm008 of Rm
	(properties
		picture scriptNumber
		north 1
		east 9
		south 15
		west 125
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (if (<= (send gEgo:x) 55)
               		(send gEgo:
               			posn(56 76)
               			loop(2)
					)
			   )(else
               		(send gEgo:
                   		posn((send gEgo:x) 76) //x is remembered
                   		loop(2)
               		)
				)
			)
            (case east
                (if (<= (send gEgo:y) 75)
                	(send gEgo:
                		posn(310 76)
                		loop(1)
					)
				)(else
                	(send gEgo:
                   		posn(310 send gEgo:y)  //y is remembered
                   		loop(1)
					)
				 )
            )
            (case west
            	(if (<= (send gEgo:y) 75)
                	(send gEgo:
                		posn(10 76)
                		loop(0)
					)
				)(else
	                (send gEgo:
    	                posn(10 send gEgo:y) //y is remembered
        	            loop(0)
            	    )
				 )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		(if (== (gPreviousRoomNumber) 125)
			(send gEgo:init()setCycle(StopWalk 5 5))
		)(else
			(send gEgo:init())
		 )
		(self:setRegions(700))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		(if (& (send gEgo:onControl()) ctlPURPLE)
			(send gRoom:newRoom(1))
		)
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/