/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 25)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm025 of Rm
	(properties
		picture scriptNumber
		north 18
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 70) //x is remembered
                   loop(2)
               )
            )
			(case 32
				(send gEgo:
					posn(169 155)
					loop(3)
				)
				= gProgramControl FALSE
				PlayerControl()
			)
		)
		
		SetUpEgo()
		(send gEgo:init())
		(Ferryman:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		
		(if(Said('get<in/boat'))
			(if(<= send gEgo:distanceTo(Ferryman) 20)
				Print("You climb into the decrepit rowboat, and the shrouded fiend paddles across the toxic lake to the shore.")
				(send gRoom:newRoom(32))
			)(else
				PrintNotCloseEnough()
			 )
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Ferryman of Prop
	(properties
		x 160
		y 180
		view 57
		loop 1
	)
)