/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 36)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm036 of Rm
	(properties
		picture scriptNumber
		north 29
		east 37
		south 43
		west 137
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(self:setRegions(700))
		(if (not (send gEgo:has(INV_TRIDENT)))
			(if (not gNeptuneTrident)
				(Trident:init()setPri(0))
			)
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (Said('take>'))
			(if (Said('/trident'))
				(if (not (send gEgo:has(INV_TRIDENT)) and (not gNeptuneTrident))
					(if (<= (send gEgo:distanceTo(Trident)) 20)
						PrintOK()
						(Trident:dispose())
						(send gGame:changeScore(3))
						(send gEgo:get(INV_TRIDENT))
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					Print("You don't see that here.")
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Trident of Prop
	(properties
		x 266
		y 151
		view 44
	)
)