/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 52)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm052 of Rm
	(properties
		picture scriptNumber
		north 0
		east 53
		south 0
		west 51
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
               (EgoSeahorse:init()setCycle(Fwd)setStep(5 5)setLoop(1))
               (RoomScript:changeState(1))
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
                ProgramControl()
                = gProgramControl TRUE
                (MenuBar:hide()state(DISABLED))
                (SL:disable())
                (EgoSeahorse:init()posn(10 98)setCycle(Fwd)setStep(5 5)setLoop(0))
				(RoomScript:changeState(3))
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 1
				// Handle state changes
				(EgoSeahorse:setMotion(MoveTo 0 98 RoomScript))
			)
			(case 2
				(send gRoom:newRoom(51))
			)
			(case 3 = cycles 1
				
			)
			(case 4
				(send gGame:setCursor(997 1))
				(EgoSeahorse:setMotion(MoveTo 320 98 RoomScript))
			)
			(case 5
				(send gRoom:newRoom(53))
			)
		)
	)
)
/******************************************************************************/
(instance EgoSeahorse of Act
	(properties
		x 310
		y 98
		view 14
		loop 1
	)
)