/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 55)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "DPath")
/******************************************************************************/
(instance public rm055 of Rm
	(properties
		picture scriptNumber
		north 0
		east 56
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		SetUpEgo()
		(switch(gPreviousRoomNumber)
            (case east
                (if(gCarpetFlying)
                	(send gEgo:init()hide())
                	(RoomScript:changeState(3))
				)(else
                	(send gEgo:
                		init()
                   		posn(310 send gEgo:y)  //y is remembered
                   		loop(1)                   		
               		)
				 )
            )
            (case 105
            	(send gEgo:
            		posn(201 91)
            		loop(0)
            		(send gEgo:init()hide())
				)
				(EgoCarpet:init()setStep(4 4)setPri(send gEgo:priority()))
				(RoomScript:changeState(1))
			)
		)
		
		
		
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('ride>'))
			(if (Said('/carpet'))
				(self:setScript(CarpetScript))
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes				
			)
			(case 1
				(EgoCarpet:			
					ignoreControl(ctlWHITE)
					setCycle(Fwd)
					setMotion(MoveTo 201 91 RoomScript)
				)
			)
			(case 2
				(send gGame:setSpeed(4))
				(EgoCarpet:dispose())
				(send gEgo:show())
				= gProgramControl FALSE
				PlayerControl()
				= gCarpetFlying FALSE
			)
			(case 3
				(EgoCarpet:
                	init()
                	setStep(4 4)
                	setPri(send gEgo:priority())
                	ignoreControl(ctlWHITE)
                	posn(320 45)
                	setCycle(Fwd)
                	setMotion(MoveTo 0 45 RoomScript)
				)
			)
			(case 4
				(send gRoom:newRoom(105))
			)
		)
	)
)
/******************************************************************************/
(instance EgoCarpet of Act
	(properties
		x 0
		y 45
		view 15
	)
)
(instance CarpetScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch(newState)
			(case 0
				ProgramControl()
				= gProgramControl TRUE
				= gCarpetFlying TRUE
				(send gEgo:hide())
				(EgoCarpet:
					init()
					setStep(4 4)
					setPri(send gEgo:priority())
					ignoreControl(ctlWHITE)
					posn((send gEgo:x) (send gEgo:y))
					loop(1)
					setCycle(Fwd)
					setMotion(DPath (- (send gEgo:x) 10) 45 0 45 CarpetScript)
				)
			)
			(case 1
				(send gRoom:newRoom(105))
			)
		)
	)
)