/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 58)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm058 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 57
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(if(== gKeyQuest 3)
			(GoldKey:init())
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (Said('take>'))
			(if (Said('/key'))
				(if (== gKeyQuest 3)
					(if (<= (send gEgo:distanceTo(GoldKey)) 30)
						PrintOK()
						(GoldKey:dispose())
						++gKeyQuest
						(send gGame:changeScore(5))
						(send gEgo:get(INV_GOLDKEY))
					)(else
						PrintNotCloseEnough()
				 	)
				)(else
					PrintAlreadyTookIt()
				 )
			)
		)
		(if(Said('ride/carpet'))
			PrintCantDoThat()
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance GoldKey of Prop
	(properties
		x 261
		y 151
		view 56
	)
)