/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 69)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm069 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 44
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(37 130)
					loop(send gEgo:loop())
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init())
		(if (not (send gEgo:has(INV_NIGHTINGALE)))
			(if (not (send gEgo:has(INV_EMPTYCAGE)))
				(if (not gAntiqueBird)
					(if (== gClothBird FALSE)
						(Nightingale:init()setCycle(Fwd))
					)(else
						(Nightingale:init()setLoop(1))
					 )
				)
			)
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (Said('put>'))
			(if (Said('/cloth/cage'))
				(if (send gEgo:has(INV_CLOTH))
					(if (<= (send gEgo:distanceTo(Nightingale)) 20)
						Print("You drape the cloth over the birdcage. Hopefully, this will keep the nightingale quiet.")
						(send gEgo:put(INV_CLOTH))
						(send gGame:changeScore(2))
						(Nightingale:setLoop(1))
						= gClothBird TRUE
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					PrintDontHaveIt()
				)
			)
		)
		(if (Said('take>'))
			(if (Said('/cage,nightingale'))
				(if (not send gEgo:has(INV_NIGHTINGALE))
					(if (not send gEgo:has(INV_EMPTYCAGE))
						(if (not gAntiqueBird)
							(if (<= (send gEgo:distanceTo(Nightingale)) 20)
								(if (== gClothBird TRUE)
									Print("Quietly, you pick up the covered birdcage with the nightingale. To your relief, the bird remains silent.")
									(Nightingale:dispose())
									(send gGame:changeScore(2))
									(send gEgo:get(INV_NIGHTINGALE))
								)(else
									Print("You pick up the gilded birdcage with the nightingale in it. The little bird starts singing prettily. A moment later it stops.")
									(Nightingale:dispose())
									(send gGame:changeScore(2))
									(send gEgo:get(INV_NIGHTINGALE))
								 )
							)(else
								PrintNotCloseEnough()
							 )
						)(else
							Print("You don't see that here.")
						 )
					)(else
						Print("You don't see that here.")
					 )
				)(else
					Print("You don't see that here.")
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Nightingale of Prop
	(properties
		x 205
		y 115
		view 45
	)
)