/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 74)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm074 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 73
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(if (not (send gEgo:has(INV_SOUP)))
			(if (not gGrandmaSoup)
				(Soup:init()setCycle(Fwd))
			)(else
				(Soup:init()view(47)setCycle(Fwd))
			 )
		)(else
			(Soup:init()view(47)setCycle(Fwd))
		 )
		(if (== gDwarfChestOpen 0)
			(Chest:init()setCel(0))
		)(else
			(Chest:init()setCel(3))
		 )
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (Said('take>'))
			(if (Said('/soup'))
				(if (not (send gEgo:has(INV_SOUP)))
					(if (<= (send gEgo:distanceTo(Soup)) 30)
						PrintOK()
						(send gEgo:get(INV_SOUP))
						(send gGame:changeScore(2))
						(Soup:view(47)setCycle(Fwd))
					)(else
						PrintNotCloseEnough()
					 )
				)(else
				 	PrintAlreadyTookIt()
				  )
			)
			(if (Said('/earrings'))
				(if (== gDwarfChestOpen 1)
					(if (not (send gEgo:has(INV_EARRINGS)))
						(if (<= (send gEgo:distanceTo(Chest)) 30)
							PrintOK()
							(send gEgo:get(INV_EARRINGS))
							(send gGame:changeScore(7))
						)(else
							PrintNotCloseEnough()
						 )
					)(else
						PrintAlreadyTookIt()
					 )
				)(else
					Print("You don't see that here.")
				 )
			)
		)
		(if (Said('open>'))
			(if (Said('/chest'))
				(if (== gDwarfChestOpen 0)
					(if (<= (send gEgo:distanceTo(Chest)) 30)
						PrintOK()
						= gDwarfChestOpen 1
						(Chest:setCycle(End))
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					PrintItIs()
				 )
			)
		)
		(if (Said('close>'))
			(if (Said('/chest'))
				(if (== gDwarfChestOpen 1)
					(if (<= (send gEgo:distanceTo(Chest)) 30)
						PrintOK()
						= gDwarfChestOpen 0
						(Chest:setCycle(Beg))
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					PrintItIs()
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Soup of Prop
	(properties
		x 103
		y 122
		view 46
	)
)
(instance Chest of Prop
	(properties
		x 214
		y 149
		view 40
	)
)