/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 77)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm077 of Rm
	(properties
		picture scriptNumber
		north 0
		east 78
		south 82
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
            (case 76
            	(send gEgo:
            		posn(235 105)
            		loop(2)
				)
				(RoomScript:changeState(1))
			)
		)
		
		SetUpEgo()
		(if(<> gPreviousRoomNumber 76)
			(send gEgo:init())
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
			(case 1
				(aRideFish:
					init()
					setCycle(Fwd)
					setStep(6 6)
					setMotion(MoveTo 100 105 RoomScript)
				)
			)
			(case 2
				(aRideFish:
					view(66)
					setStep(8 8)
					setCycle(Fwd)
					setMotion(MoveTo 235 105 RoomScript)
				)
			)
			(case 3 = cycles 15
				(aRideFish:
					loop(1)
					setCycle(Fwd)
					cycleSpeed(1)
				)
			)
			(case 4
				(aRideFish:dispose())
				(send gEgo:init())
				PlayerControl()
				= gProgramControl FALSE
			)
		)
	)
)
/******************************************************************************/
(instance aRideFish of Act
	(properties
		x 0
		y 105
		view 38
		loop 0
	)
)