/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 111)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "menubar")
/******************************************************************************/
(instance public rm111 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(send gGame:setSpeed(6))
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn((send gEgo:x) (send gEgo:y))//150 130)
					loop (send gEgo:loop())//loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
		(TheMenuBar:hide()state(DISABLED))
		(send gGame:setCursor(0 0))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch (state)
			(case 0 
				(= cycles 1)
			)
			(case 1 = cycles 40
				(send gGame:setCursor(0 0))
				ProgramControl()
				= gProgramControl TRUE
			)
			(case 2 = cycles 70
				Display("The Sarien Encounter"
					dsALIGN alCENTER
					dsFONT 9
					dsCOORD 59 156
					dsCOLOUR clMAROON
					dsBACKGROUND clTRANSPARENT
					   )
			)
			(case 3
				(send gRoom:newRoom(112))
			)
		)
	)
		
	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (== (send pEvent:type) evKEYBOARD)
           	(if (== (send pEvent:message) KEY_ESCAPE)
           		ProgramControl()
				= gProgramControl FALSE
				(send gRoom:newRoom(1))
			)(else
				(if (== (send pEvent:message) KEY_RETURN)
					ProgramControl()
					= gProgramControl FALSE
					(send gRoom:newRoom(1))
				)
			 )
		)					
		(if(== (send pEvent:type()) evMOUSEBUTTON)
			ProgramControl()
			= gProgramControl FALSE
			(send gRoom:newRoom(1))
		)
	)
)
/******************************************************************************/
