/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 140)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm140 of Rm
	(properties
		picture 50
		north 137
		east 43
		south 122
		west 139
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 75) //x is remembered
                   loop(2)
               )
            )
            (case east
               (if (< (send gEgo:y) 75)
               		(send gEgo:
               			posn(310 75)
               			loop(1)
					)
			   )(else
               		(send gEgo:
                   		posn(310 (send gEgo:y))  //y is remembered
                   		loop(1)
					)
				)
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
			(default
				(send gEgo:
					posn(150 130)
					loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()setCycle(StopSwim gEgoSwimming gEgoSwimming))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		(if (& (send gEgo:onControl()) ctlPURPLE)
			(send gRoom:newRoom(137))
		)
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
