/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script INTROCREDITS_SCRIPT)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm801 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(150 130)
					loop(1)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0 = cycles 40
				Display("Credit sequence\n"+
					"from intro."
					dsCOORD 60 52
					dsALIGN alCENTER
					dsWIDTH 200
					dsFONT 1
					dsCOLOUR clWHITE
					dsBACKGROUND clTRANSPARENT
					)
			)
			(case 1
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			)
		)
	)
)
/******************************************************************************/
